# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/3/16
import json
import os
import random
import shutil
import sys
import time
from hashlib import md5
import requests
import urllib3
sys.path.append(os.getcwd())
from common.common import Common
from common.feishu import Feishu
from common.publish import Publish
from common.scheduling_db import MysqlHelper
from common.public import get_config_from_mysql, download_rule
proxies = {"http": None, "https": None}


class XiaoniangaoplayScheduling:
    platform = "小年糕"
    words = "abcdefghijklmnopqrstuvwxyz0123456789"
    uid_token_dict = {
        "uid": f"""{"".join(random.sample(words, 8))}-{"".join(random.sample(words, 4))}-{"".join(random.sample(words, 4))}-{"".join(random.sample(words, 4))}-{"".join(random.sample(words, 12))}""",
        "token": "".join(random.sample(words, 32))}

    # 获取列表
    @classmethod
    def get_videoList(cls, log_type, crawler, rule_dict, our_uid, env):
        uid_token_dict = cls.uid_token_dict
        for page in range(1, 101):
            try:
                Common.logger(log_type, crawler).info(f"正在抓取第{page}页")
                url = "https://kapi.xiaoniangao.cn/trends/get_recommend_trends"
                headers = {
                    "x-b3-traceid": '1dc0a6d0929a2b',
                    "X-Token-Id": 'ae99a4953804085ebb0ae36fa138031d-1146052582',
                    "uid": uid_token_dict['uid'],
                    "content-type": "application/json",
                    "Accept-Encoding": "gzip,compress,br,deflate",
                    "User-Agent": 'Mozilla/5.0 (iPhone; CPU iPhone OS 14_7_1 like Mac OS X)'
                                  ' AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 '
                                  'MicroMessenger/8.0.20(0x18001432) NetType/WIFI Language/zh_CN',
                    "Referer": 'https://servicewechat.com/wxd7911e4c177690e4/620/page-frame.html'
                }
                data = {
                    "log_params": {
                        "page": "discover_rec",
                        "common": {
                            "brand": "iPhone",
                            "device": "iPhone 11",
                            "os": "iOS 14.7.1",
                            "weixinver": "8.0.20",
                            "srcver": "2.24.2",
                            "net": "wifi",
                            "scene": 1089
                        }
                    },
                    "qs": "imageMogr2/gravity/center/rotate/$/thumbnail/!750x500r/crop/750x500/interlace/1/format/jpg",
                    "h_qs": "imageMogr2/gravity/center/rotate/$/thumbnail/!80x80r/crop/80x80/interlace/1/format/jpg",
                    "share_width": 625,
                    "share_height": 500,
                    "ext": {
                        "fmid": 0,
                        "items": {}
                    },
                    "app": "xng",
                    "rec_scene": "discover_rec",
                    "log_common_params": {
                        "e": [{
                            "data": {
                                "page": "discoverIndexPage",
                                "topic": "recommend"
                            },
                            "ab": {}
                        }],
                        "ext": {
                            "brand": "iPhone",
                            "device": "iPhone 11",
                            "os": "iOS 14.7.1",
                            "weixinver": "8.0.20",
                            "srcver": "2.24.3",
                            "net": "wifi",
                            "scene": "1089"
                        },
                        "pj": "1",
                        "pf": "2",
                        "session_id": "7bcce313-b57d-4305-8d14-6ebd9a1bad29"
                    },
                    "refresh": False,
                    # "token": cls.play_token,
                    "token": uid_token_dict['token'],
                    # "uid": cls.play_uid,
                    "uid": uid_token_dict['uid'],
                    "proj": "ma",
                    "wx_ver": "8.0.20",
                    "code_ver": "3.62.0"
                }
                urllib3.disable_warnings()
                r = requests.post(url=url, headers=headers, json=data, proxies=proxies, verify=False)
                if "data" not in r.text or r.status_code != 200:
                    Common.logger(log_type, crawler).warning(f"get_videoList:{r.text}\n")
                    return
                elif "data" not in r.json():
                    Common.logger(log_type, crawler).info(f"get_videoList:{r.json()}\n")
                    return
                elif "list" not in r.json()["data"]:
                    Common.logger(log_type, crawler).warning(f"get_videoList:{r.json()['data']}\n")
                    return
                elif len(r.json()["data"]["list"]) == 0:
                    Common.logger(log_type, crawler).warning(f"get_videoList:{r.json()['data']['list']}\n")
                    return
                else:
                    # 视频列表数据
                    feeds = r.json()["data"]["list"]
                    for i in range(len(feeds)):
                        try:
                            # 标题，表情随机加在片头、片尾，或替代句子中间的标点符号
                            xiaoniangao_title = feeds[i].get("title", "").strip().replace("\n", "") \
                                .replace("/", "").replace("\r", "").replace("#", "") \
                                .replace(".", "。").replace("\\", "").replace("&NBSP", "") \
                                .replace(":", "").replace("*", "").replace("？", "") \
                                .replace("?", "").replace('"', "").replace("<", "") \
                                .replace(">", "").replace("|", "").replace(" ", "") \
                                .replace('"', '').replace("'", '')
                            # 随机取一个表情/符号
                            emoji = random.choice(get_config_from_mysql(log_type, crawler, env, "emoji"))
                            # 生成最终标题，标题list[表情+title, title+表情]随机取一个
                            video_title = random.choice([f"{emoji}{xiaoniangao_title}", f"{xiaoniangao_title}{emoji}"])
                            # 发布时间
                            publish_time_stamp = int(int(feeds[i].get("t", 0)) / 1000)
                            publish_time_str = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(publish_time_stamp))
                            # 用户名 / 头像
                            user_name = feeds[i].get("user", {}).get("nick", "").strip().replace("\n", "") \
                                .replace("/", "").replace("快手", "").replace(" ", "") \
                                .replace(" ", "").replace("&NBSP", "").replace("\r", "")

                            video_dict = {
                                "video_title": video_title,
                                "video_id": feeds[i].get("vid", ""),
                                "duration": int(feeds[i].get("du", 0) / 1000),
                                "play_cnt": feeds[i].get("play_pv", 0),
                                "like_cnt": feeds[i].get("favor", {}).get("total", 0),
                                "comment_cnt": feeds[i].get("comment_count", 0),
                                "share_cnt": feeds[i].get("share", 0),
                                "user_name": user_name,
                                "publish_time_stamp": publish_time_stamp,
                                "publish_time_str": publish_time_str,
                                "video_width": int(feeds[i].get("w", 0)),
                                "video_height": int(feeds[i].get("h", 0)),
                                "avatar_url": feeds[i].get("user", {}).get("hurl", ""),
                                "profile_id": feeds[i]["id"],
                                "profile_mid": feeds[i]["user"]["mid"],
                                "cover_url": feeds[i].get("url", ""),
                                "video_url": feeds[i].get("v_url", ""),
                                "session": f"xiaoniangao-play-{int(time.time())}"

                            }
                            for k, v in video_dict.items():
                                Common.logger(log_type, crawler).info(f"{k}:{v}")

                            # 过滤无效视频
                            if video_title == "" or video_dict["video_id"] == "" or video_dict["video_url"] == "":
                                Common.logger(log_type, crawler).warning("无效视频\n")
                            # 抓取基础规则过滤
                            elif download_rule(log_type=log_type, crawler=crawler, video_dict=video_dict, rule_dict=rule_dict) is False:
                                Common.logger(log_type, crawler).info("不满足抓取规则\n")
                            elif any(str(word) if str(word) in video_dict["video_title"] else False
                                     for word in get_config_from_mysql(log_type=log_type,
                                                                       source=crawler,
                                                                       env=env,
                                                                       text="filter",
                                                                       action="")) is True:
                                Common.logger(log_type, crawler).info('已中过滤词\n')
                            elif cls.repeat_video(log_type, crawler, video_dict['video_id'], env) != 0:
                                Common.logger(log_type, crawler).info('视频已下载\n')
                            else:
                                cls.download_publish(log_type=log_type,
                                                     crawler=crawler,
                                                     video_dict=video_dict,
                                                     rule_dict=rule_dict,
                                                     our_uid=our_uid,
                                                     env=env)
                        except Exception as e:
                            Common.logger(log_type, crawler).error(f"抓取单条视频异常:{e}\n")
            except Exception as e:
                Common.logger(log_type, crawler).error(f"抓取第{page}页时异常:{e}\n")

    @classmethod
    def repeat_video(cls, log_type, crawler, video_id, env):
        sql = f""" select * from crawler_video where platform="{cls.platform}" and out_video_id="{video_id}"; """
        repeat_video = MysqlHelper.get_values(log_type, crawler, sql, env)
        return len(repeat_video)

    @classmethod
    def download_publish(cls, log_type, crawler, video_dict, rule_dict, our_uid, env):
        # 下载视频
        Common.download_method(log_type=log_type, crawler=crawler, text="video", title=video_dict["video_title"], url=video_dict["video_url"])
        md_title = md5(video_dict['video_title'].encode('utf8')).hexdigest()
        try:
            if os.path.getsize(f"./{crawler}/videos/{md_title}/video.mp4") == 0:
                # 删除视频文件夹
                shutil.rmtree(f"./{crawler}/videos/{md_title}")
                Common.logger(log_type, crawler).info("视频size=0，删除成功\n")
                return
        except FileNotFoundError:
            # 删除视频文件夹
            shutil.rmtree(f"./{crawler}/videos/{md_title}")
            Common.logger(log_type, crawler).info("视频文件不存在，删除文件夹成功\n")
            return
        # 下载封面
        Common.download_method(log_type=log_type, crawler=crawler, text="cover", title=video_dict["video_title"], url=video_dict["cover_url"])
        # 保存视频信息至 "./videos/{download_video_title}/info.txt"
        Common.save_video_info(log_type=log_type, crawler=crawler, video_dict=video_dict)

        # 上传视频
        Common.logger(log_type, crawler).info("开始上传视频...")
        if env == "dev":
            oss_endpoint = "out"
            our_video_id = Publish.upload_and_publish(log_type=log_type,
                                                      crawler=crawler,
                                                      strategy="播放量抓取策略",
                                                      our_uid=our_uid,
                                                      env=env,
                                                      oss_endpoint=oss_endpoint)
            our_video_link = f"https://testadmin.piaoquantv.com/cms/post-detail/{our_video_id}/info"
        else:
            oss_endpoint = "inner"
            our_video_id = Publish.upload_and_publish(log_type=log_type,
                                                      crawler=crawler,
                                                      strategy="播放量抓取策略",
                                                      our_uid=our_uid,
                                                      env=env,
                                                      oss_endpoint=oss_endpoint)

            our_video_link = f"https://admin.piaoquantv.com/cms/post-detail/{our_video_id}/info"

        if our_video_id is None:
            try:
                # 删除视频文件夹
                shutil.rmtree(f"./{crawler}/videos/{md_title}")
                return
            except FileNotFoundError:
                return

        insert_sql = f""" insert into crawler_video(video_id,
                                                    out_user_id,
                                                    platform,
                                                    strategy,
                                                    out_video_id,
                                                    video_title,
                                                    cover_url,
                                                    video_url,
                                                    duration,
                                                    publish_time,
                                                    play_cnt,
                                                    crawler_rule,
                                                    width,
                                                    height)
                                                    values({our_video_id},
                                                    "{video_dict['profile_id']}",
                                                    "{cls.platform}",
                                                    "播放量抓取策略",
                                                    "{video_dict['video_id']}",
                                                    "{video_dict['video_title']}",
                                                    "{video_dict['cover_url']}",
                                                    "{video_dict['video_url']}",
                                                    {int(video_dict['duration'])},
                                                    "{video_dict['publish_time_str']}",
                                                    {int(video_dict['play_cnt'])},
                                                    '{json.dumps(rule_dict)}',
                                                    {int(video_dict['video_width'])},
                                                    {int(video_dict['video_height'])}) """
        Common.logger(log_type, crawler).info(f"insert_sql:{insert_sql}")
        MysqlHelper.update_values(log_type, crawler, insert_sql, env)
        Common.logger(log_type, crawler).info('视频信息写入数据库成功')

        # 视频写入飞书
        Feishu.insert_columns(log_type, crawler, "c85k1C", "ROWS", 1, 2)
        # 视频ID工作表，首行写入数据
        upload_time = int(time.time())
        values = [[time.strftime("%Y-%m-%d %H:%M:%S", time.localtime(upload_time)),
                   "播放量榜爬虫策略",
                   str(video_dict['video_id']),
                   str(video_dict['video_title']),
                   our_video_link,
                   video_dict['play_cnt'],
                   video_dict['comment_cnt'],
                   video_dict['like_cnt'],
                   video_dict['share_cnt'],
                   video_dict['duration'],
                   f"{video_dict['video_width']}*{video_dict['video_height']}",
                   str(video_dict['publish_time_str']),
                   str(video_dict['user_name']),
                   str(video_dict['profile_id']),
                   str(video_dict['profile_mid']),
                   str(video_dict['avatar_url']),
                   str(video_dict['cover_url']),
                   str(video_dict['video_url'])]]
        time.sleep(0.5)
        Feishu.update_values(log_type, crawler, "c85k1C", "F2:Z2", values)
        Common.logger(log_type, crawler).info('视频信息写入飞书成功\n')


if __name__ == '__main__':

    pass
